;----------------------------------------------------------------
;	test.asm prog to drive mono screen			;
;	masm32 version						;
;	Roger Stone 7-4-2006					;
;----------------------------------------------------------------
.486                                      ; create 32 bit code
.model flat, stdcall                      ; 32 bit memory model

include \prog\winiolib\winio.inc
includelib \prog\winiolib\winio.lib
;----------------------------------------------------------------
.data
	hMonoScreen	dd 0		; handle for mono screen
	monopntr	dd 0		; pointer to mono screen
	monobase	dd 0		; Start address of mono image
	messagestg	db 0Ah," This is a String ",0Ah," Over two lines",0
;----------------------------------------------------------------
.code
start:
    	call InitializeWinIo		; initialiseWinIo 
 
	push offset hMonoScreen		; address to save handle to mono memory space
	push 1				; no of bytes (this should be 4000 but anything >0 works!)
	push 0B0000h			; pointor to phsycal address of mono adaptor
	call MapPhysToLin		; map mono screen to memory
	mov monobase,eax		; save address of mono image

;----------------------------------------------------------------
	; Now some temporary code just to make it do something
	mov ecx, 019h			; 25 scrolls clears screen
s1:	push ecx
	mov ebx, monopntr
	call scroll			; Slow enough to see it work!!
	pop ecx
	loop s1	
		; Display character set
	mov ebx, monobase 
	add ebx, 00500h			; point to row 8
	mov ax,  0700h 			; start at 0 with normal attribute
	mov ecx, 0100h			; count for 256 chars 
lp1:	mov word ptr[ebx],ax		; send char  
	inc ebx
	inc ebx				; next char
	inc al				; change char
	loop lp1
		; Display atributes of a mono screen
	add ebx,001C0h			; point to 3+ rows down
	mov ax, 0058h 			; start at attribute 00 with char X
	mov ecx,0100h			; count for 256 chars 
lp2: 	mov word ptr[ebx],ax		; send char  
	inc ebx
	inc ebx				; next char
	inc ah				; change attibute
	loop lp2
		; Display a double word and a byte
	mov monopntr, 0D20h
	mov eax, 012EDh
	call monodouble
	mov al, " "
	call monochar
	mov al, 55h
	call monobyte
		; Display a string
	mov esi, offset messagestg
	call monostring
;----------------------------------------------------------------
		; Shut down programme
	push ebx			; pointer to memory image
	push offset hMonoScreen		; address of handle to mono memory space
	call UnmapPhysicalMemory	; release image of mono screen
    
	call ShutdownWinIo		;clean up WinIo  
	ret
		; end of main programme
;--------------------------------------------------------------
;	Subroutines
;--------------------------------------------------------------
monostring:	; send a string to mono screen p0inted to by esi 
	mov ah,07h		; set attribute
l1:	lodsb
	or al,al		; test char
	jz l2			; zero marks end of string
	call monochar
	loop l1
l2:	ret
;------------
monodouble:	;output double word in hex
	push eax
	shr eax,16
	call monoword
	pop eax
monoword:	; output word in hex
	push ax
	mov al,ah
	call monobyte
	pop ax
monobyte:	; output byte in hex
	push ax
	shr al,4
	call mononibble
	pop ax
mononibble:	;output nibble in hex
	and ax,000Fh		; just use nibble
	add al,90h		; range is 90-9F
	daa			; 9A-9F will be adjusted + set carry
	adc al,40h		; range is now D0-D9,40-45
	daa			; range is 30-3F,41-45
monochar:	; output char to mono screen
	mov ebx, monopntr	;do this now before possible scroll
	cmp al,0Dh
	je scroll		; quicky cr-lf 
	cmp al,0Ah		; only works if all input to bottom row
	je scroll
	mov ah, 07		; attribute = normal 
	add ebx, 2			
	cmp ebx, 4000		; at end of screen?	
	jna noscroll
scroll:		;scroll up one line
	push esi
	push edi
	mov edi, monobase	; top of screen
	mov esi, edi		
	add esi, 00160		; 2x80 byts per line
	mov ecx, 0960		; 24 x 80 words 2 at a time
	rep movsd
		;blank out bottom line
	mov ax, 0720h		; attribute + "space"
	mov cx, 080
	rep stosw		; clearfill bottom line
	mov ebx, 0F00h
	sub ebx, 0A0h		; addjust pointer
	pop edi
	pop esi
noscroll:
	mov monopntr, ebx
	add ebx, monobase
	mov word ptr[ebx], ax 
	ret

;----------------------------------------------------------------
end start
 
